#include "ant.h"

#include <QGraphicsScene>
#include <QPainter>
#include <QStyleOption>
#include <QMessageBox>

Ant::Ant(QColor color, int const &radius)
{
    this->color = color;
    this->radius = radius;
    image = QImage(":/images/furnica.png");
}

Ant::Ant()
{
    color = QColor(Qt::blue);
}

QRectF Ant::boundingRect() const
{    
    return QRectF(-radius, -radius, radius, radius);
}

QPainterPath Ant::shape() const
{
    QPainterPath path;
    path.addRect(-radius, -radius, radius, radius);
    return path;
}

void Ant::paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *)
{
    QRadialGradient radialGrad(QPointF(-8, -8), 20);
    radialGrad.setColorAt(0, Qt::white);
    radialGrad.setColorAt(1, color);

    painter->setBrush(QBrush(radialGrad));
    painter->drawImage(-image.width()/2,-image.height()/2,image);
    //painter->drawEllipse(QPoint(0,0), radius, radius);
}
