#ifndef ANTWORLD_H
#define ANTWORLD_H

#include <QGraphicsView>
#include <QGraphicsScene>

class QTimer;
class QImage;
class QWheelEvent;

class AntWorld: public QGraphicsView
{
    Q_OBJECT
    
public:
    AntWorld (QGraphicsScene * scene, QWidget * parent = 0 );
    void setWorldSize(int const &ws);
    int worldSize() const;
    void setStageSize(int const &ss);
    void setHome(int const &x, int const &y);
    void setFood(int const &x, int const &y);
    void setShortestPathThisGen(QPainterPath const &path);
    void setShortestPathSoFar(QPainterPath const &path);
    void showShortestPathThisGen(bool const &show);
    void showShortestPathSoFar(bool const &show);
    void showTrails(bool const &show);
    void setShowGrid(bool const &show);
    void setBlockingPath(QPainterPath const &path);
    void setPheromoneTrails(double **matrix);
    
private:
    QImage homeImage;
    QImage foodImage;
    QPainterPath shortestPathThisGen;
    QPainterPath shortestPathSoFar;
    QPainterPath blockingPath;
    double **pheromoneTrailsMatrix;
    bool showSPathTG;
    bool showSPathSF;
    bool showGrid;
    bool showPheromoneTrails;
    int homeX, homeY;
    int foodX, foodY;
    int WORLDSIZE;
    int STAGESIZE;

    
protected:
    void drawBackground(QPainter * painter, const QRectF & rect );

};
#endif
