/*---- TODO --------------------------------------------------------------naltu
 *-------------------------------------------------------------VERSION-0.5.3---
 *	#BUGFIX: 
 *	-
 *	-
 *	-
 *	-
 *
 *	#ADDFUNCTION: 
 *	-
 *
 *---------------------------------------------------------------------------*/

/******************************************************************************
 *	FVNCTI0NES
 *	
 *****************************************************************************/
#include "libantcol.h"

AntCol::AntCol()
{
    srand((unsigned)time(NULL));

    //PARAMETERS
    WORLD_SIZE 		= 5;
    TABU_SIZE 		= WORLD_SIZE * WORLD_SIZE;
    BLOCKED_SIZE 	= TABU_SIZE;
    FOOD_LOCATION_X 	= WORLD_SIZE-1;
    FOOD_LOCATION_Y 	= WORLD_SIZE-1;
    HOME_LOCATION_X 	= 0;
    HOME_LOCATION_Y 	= 0;
    ANTS		= 5;
    
    //initializers&multiplyers
    PHEROMONE_ALPHA 	= 1; 	//factor feromon
    HEURISTIC_BETA  	= 1; 	//factor euristic
    PHEROMONE_EVAP_RO 	= 0.06;	//factor de evaporare
    PHEROMONE_QUANTITY 	= 1.0;	//cantitate de feromon
    INIT_ROUTING_TABLE	= 1;
    INIT_PHEROMONE_TAU	= 0;
    INIT_HEURISTIC_ETA	= 1;

    //rewards
    FOOD_REWARD		= 100;
    BLOCKED_REWARD	= -100;
    //alloc memory
    routingTable = 0;
    tauMatrix = 0;
    etaMatrix = 0;
    blockedMatrix = 0;
    antsVector = 0;
    reinitialize();    
}

AntCol::AntCol(int const &size, int const &ants)
{
    srand((unsigned)time(NULL));
    //PARAMETERS
    WORLD_SIZE 		= size;
    TABU_SIZE 		= WORLD_SIZE * WORLD_SIZE;
    BLOCKED_SIZE 	= TABU_SIZE;
    FOOD_LOCATION_X 	= WORLD_SIZE-1;
    FOOD_LOCATION_Y 	= WORLD_SIZE-1;
    HOME_LOCATION_X 	= 0;
    HOME_LOCATION_Y 	= 0;
    ANTS		= ants;
    
    //initializers&multiplyers
    PHEROMONE_ALPHA 	= 2; 	//factor feromon
    HEURISTIC_BETA  	= 1; 	//factor euristic
    PHEROMONE_EVAP_RO 	= 0.1;	//factor de evaporare
    PHEROMONE_QUANTITY 	= 1.0;	//cantitate de feromon
    INIT_ROUTING_TABLE	= 1;
    INIT_PHEROMONE_TAU	= 0;
    INIT_HEURISTIC_ETA	= 1;
    
    //rewards
    FOOD_REWARD		= 100;
    BLOCKED_REWARD	= -100;
    
    //alloc memory
    // set null pointer so the 1st time reinitialize()
    // is called the tables would'n be deleted
    routingTable = 0;
    tauMatrix = 0;
    etaMatrix = 0;
    blockedMatrix = 0;
    antsVector = 0;
    reinitialize();
}

AntCol::~AntCol()
{
    delete[] routingTable;
    delete[] tauMatrix;
    delete[] etaMatrix;
    delete[] blockedMatrix;
    delete[] antsVector;
}

void AntCol::reinitialize()
{
    if (routingTable)
    {
        delete[] routingTable;
        delete[] tauMatrix;
        delete[] etaMatrix;
        delete[] blockedMatrix;
        delete[] antsVector;
    }

    antSuccessful 	= 0;
    antFailed 		= 0;
    routingTable 	= newMatrixDouble(WORLD_SIZE, WORLD_SIZE);
    tauMatrix 		= newMatrixDouble(WORLD_SIZE, WORLD_SIZE);
    etaMatrix 		= newMatrixDouble(WORLD_SIZE, WORLD_SIZE);    ;
    blockedMatrix 	= newMatrixInt(2, BLOCKED_SIZE);
    antsVector 		= new ant[ANTS];
    
    for (int i=0; i<ANTS; i++)
    {
	antsVector[i].tabuMatrix = newMatrixInt(2, TABU_SIZE);
    }
      
    refreshMemory();
    blockedCount = 0;   
    
    for(int i=0; i<WORLD_SIZE; i++)
	for(int j=0; j<WORLD_SIZE; j++)
	{
	    tauMatrix[i][j] 	= INIT_PHEROMONE_TAU;
	    etaMatrix[i][j] 	= INIT_HEURISTIC_ETA;
	    routingTable[i][j] 	= INIT_ROUTING_TABLE;
	}
    routingTable[FOOD_LOCATION_X][FOOD_LOCATION_Y] = FOOD_REWARD;
}

//random number generator
double AntCol::generateRandom(double const range_min, 
			      double const range_max) const
{
    double rr = (((double)rand()/(double)RAND_MAX) * range_max + range_min);
    return rr;
}

//alocare dinamica de matrice (int) 
int** AntCol::newMatrixInt(int const &m, int const &n)
{
	int *p, **q;
	int i;
	
	p = new int[m*n];
	q = (int**)(new int[m]);

	for (i=0; i<m; i++)
	{
		q[i] = p;
		p += n;
	}
	return q;
}

//alocare dinamica de matrice (double) 
double** AntCol::newMatrixDouble(int const &m, int const &n)
{
	double *p, **q;
	int i;
	
	p = new double[m*n];
	q = (double**)(new double[m]);

	for (i=0; i<m; i++)
	{
		q[i] = p;
		p += n;
	}
	return q;
}

// DEBUG
//functii de afisare DEBUG 
void AntCol::showRoutingTable() const
{
    cout<<"\n--Tabela de rutare:\n";
    for (int i=0; i<WORLD_SIZE; i++)
    {
	for (int j=0; j<WORLD_SIZE; j++)
	    cout<<setprecision(2)<<setw(5)<<routingTable[i][j]<<" ";
	cout<<endl;
    }
    
    cout<<"--Tabela cu feromon:\n";
    for (int i=0; i<WORLD_SIZE; i++)
    {
	for (int j=0; j<WORLD_SIZE; j++)
	    cout<<setprecision(3)<<setw(5)<<tauMatrix[i][j]<<" ";
	cout<<endl;
    }
    
    cout<<"--Tabela euristica:\n";
    for (int i=0; i<WORLD_SIZE; i++)
    {
	for (int j=0; j<WORLD_SIZE; j++)
	    cout<<setprecision(3)<<setw(5)<<etaMatrix[i][j]<<" ";
	cout<<endl;
    }
}

//afis tabela de rutare
void AntCol::showMatrix(int const &whichAnt) const 
{
//bool ok=false;
    cout<<"--Tabela de rutare"<<endl;
    for (int i=0; i<WORLD_SIZE; i++)
    {
	for (int j=0; j<WORLD_SIZE; j++)
	{
	    /*for (int k=0; k<positionInTabu; k++)
	    	if (i == tabuMatrix[k][0] && j==tabuMatrix[k][1] )
		{
		    ok = true;
		    break;
		}*/
		if (inTabu(whichAnt,i,j))  
		    cout<<"X"<<" ";	 
		else if (inBlocked(i,j))
		    cout<<"o"<<" ";
			else cout<<"_"<<" ";
		//ok=false;
	}
	cout<<endl;
    }
    //cout<<"------------------------------------"<<endl<<endl;
}

// afis toti pasii parursi de furnica whichAnt
void AntCol::showSteps(int const &whichAnt) const
{
    for (int i=0; i<antsVector[whichAnt].positionInTabu; i++)
    {
        cout<<"("<<antsVector[whichAnt].tabuMatrix[0][i]<<". "
            <<antsVector[whichAnt].tabuMatrix[1][i]<<")\n";
    }
}

//cauta in tabu
bool AntCol::inTabu(int const &whichAnt, int const &x, int const &y) const
{
    if (whichAnt >= 0 && whichAnt < ANTS ) //{
	for (int i=0; i<antsVector[whichAnt].positionInTabu; i++)
	    if (x == antsVector[whichAnt].tabuMatrix[0][i] && 
		y == antsVector[whichAnt].tabuMatrix[1][i])
		return true;
    //} else cerr<<" Error: Ant does not exist!\n";
    return false;
}

//cauta in blocked
bool AntCol::inBlocked(int const &x, int const &y) const
{
    for (int i=0; i<blockedCount; i++)
	if (x == blockedMatrix[0][i] && 
	    y == blockedMatrix[1][i])
	    return true;
    return false;
}

//search in matrix
bool AntCol::inMatrix(int **matrix, int const &count,
		      int const &x, int const &y) const
{
    for (int i=0; i<count; i++)
	if (x == matrix[0][i] && 
	    y == matrix[1][i])
	    return true;
    return false;
}

//adauga o celula care este blocata
void AntCol::addToBlocked(int const &x, int const &y)
{
    if (x < WORLD_SIZE && y < WORLD_SIZE)
    {
	blockedMatrix[0][blockedCount] = x;
	blockedMatrix[1][blockedCount] = y;
	blockedCount++;
    }
}

//init&refresh globalVariables 
void AntCol::refreshMemory()
{  
    for (int i=0; i<ANTS; i++)
    {
        antsVector[i].positionInTabu 	= 1;
        antsVector[i].stepsCount	= 1;
	antsVector[i].positionX 	= HOME_LOCATION_X;
	antsVector[i].positionY 	= HOME_LOCATION_Y;
	antsVector[i].tabuMatrix[0][0]	= HOME_LOCATION_X;
	antsVector[i].tabuMatrix[1][0]	= HOME_LOCATION_Y;
	antsVector[i].gotFood 		= false;
	antsVector[i].gotBlocked	= false;
    }
}

//set the world max xells
void AntCol::setWorldSize(int const &size) 
{ 
    WORLD_SIZE 	 = size;
    TABU_SIZE	 = WORLD_SIZE * WORLD_SIZE;
    BLOCKED_SIZE = TABU_SIZE;
};

//set food
void AntCol::setFoodLocation(int const &x, int const &y)
{
    if (x >= 0 && x < WORLD_SIZE)
        FOOD_LOCATION_X = x;
    else
        FOOD_LOCATION_X = WORLD_SIZE-1;

    if (y >= 0 && y < WORLD_SIZE)
        FOOD_LOCATION_Y = y;
    else
        FOOD_LOCATION_Y = WORLD_SIZE-1;

};

//set home
void AntCol::setHomeLocation(int const &x, int const &y)
{
    if (x >= 0 && x < WORLD_SIZE)
        HOME_LOCATION_X = x;
    else
        HOME_LOCATION_X = 0;

    if (y >= 0 && y < WORLD_SIZE)
        HOME_LOCATION_Y = y;
    else
        HOME_LOCATION_Y = 0;
}

int AntCol::foodLocationX() const
{
    return FOOD_LOCATION_X;
}

int AntCol::foodLocationY() const
{
    return FOOD_LOCATION_Y;
}

int AntCol::homeLocationX() const
{
    return HOME_LOCATION_X;
}

int AntCol::homeLocationY() const
{
    return HOME_LOCATION_Y;
}

//set ants
void AntCol::setHowManyAnts(int const &ants)
{
    ANTS = ants;
}  

void AntCol::setPheromoneAlpha(int const &alpha)
{
    PHEROMONE_ALPHA = alpha;
}

void AntCol::setHeuristicBeta(int const &beta)
{
    HEURISTIC_BETA = beta;
}

void AntCol::setPheromoneEvap(double const &evap)
{
    PHEROMONE_EVAP_RO = evap;
}

int AntCol::pheromoneAlpha() const
{
    return PHEROMONE_ALPHA;
}

int AntCol::heuristicBeta() const
{
    return HEURISTIC_BETA;
}

double AntCol::pheromoneEvap() const
{
    return PHEROMONE_EVAP_RO;
}

int AntCol::howManyAnts() const
{
    return ANTS;
}

int AntCol::worldSize() const
{
    return WORLD_SIZE;
}

//returns the number of ants that got food
int AntCol::successful() const
{
    return antSuccessful;
}

//returns the number of ants that failed to get to food
int AntCol::failed() const
{
    return antFailed;
}

double** AntCol::pheromoneMatrix()
{

    return tauMatrix;
}

//calculeaza urmatorul pas 
bool AntCol::nextStep(int const &whichAnt, int &x, int &y)
{
float    probabilities[8];
int      stepX=-1, stepY=-1;
int      i;
int	 possibleStepsMatrix[2][8];
int	 possibleStepsCount = -1;
//int      maxValues = 0;
float	 sigma = 0.0;
float	 inter = 0.0;
float	 randomPoint;

    //verifica pasii posibili
    //(x,y-1)
    if (antsVector[whichAnt].positionY > 0 )
    {
        if (!inBlocked(antsVector[whichAnt].positionX, 
			antsVector[whichAnt].positionY-1) && 
	    !inTabu(whichAnt, antsVector[whichAnt].positionX,
			antsVector[whichAnt].positionY-1))
        {
	    //daca tinta este adiacenta pozitiei curente
	    if (antsVector[whichAnt].positionX == FOOD_LOCATION_X &&
		antsVector[whichAnt].positionY-1 == FOOD_LOCATION_Y)
	    {
		x = antsVector[whichAnt].positionX;
		y = antsVector[whichAnt].positionY - 1;
		return true;
	    }		
            sigma += routingTable[antsVector[whichAnt].positionX]
				 [antsVector[whichAnt].positionY - 1];
            possibleStepsCount++;
            possibleStepsMatrix[0][possibleStepsCount] =
				    antsVector[whichAnt].positionX;
	    possibleStepsMatrix[1][possibleStepsCount] = 
				    antsVector[whichAnt].positionY-1;
        }

	//(x-1,y-1)
        if (antsVector[whichAnt].positionX > 0)
	    if (!inBlocked(antsVector[whichAnt].positionX-1, 
			   antsVector[whichAnt].positionY-1) && 
		!inTabu(whichAnt, antsVector[whichAnt].positionX-1, 
			antsVector[whichAnt].positionY-1))
            {
		if (antsVector[whichAnt].positionX-1 == FOOD_LOCATION_X &&
		    antsVector[whichAnt].positionY-1 == FOOD_LOCATION_Y)
		{
		    x = antsVector[whichAnt].positionX - 1;
		    y = antsVector[whichAnt].positionY - 1;
		    return true;
		}
                sigma += routingTable[antsVector[whichAnt].positionX - 1]
				     [antsVector[whichAnt].positionY - 1];
                possibleStepsCount++;
                possibleStepsMatrix[0][possibleStepsCount] = 
				    antsVector[whichAnt].positionX-1;
                possibleStepsMatrix[1][possibleStepsCount] = 
				    antsVector[whichAnt].positionY-1;
            }
    }

    //(x,y+1)
    if (antsVector[whichAnt].positionY < WORLD_SIZE-1)
    {
	if (!inBlocked(antsVector[whichAnt].positionX, 
		       antsVector[whichAnt].positionY+1) && 
	    !inTabu(whichAnt, antsVector[whichAnt].positionX, 
		    antsVector[whichAnt].positionY+1))
        {
	    if (antsVector[whichAnt].positionX == FOOD_LOCATION_X &&
		antsVector[whichAnt].positionY+1 == FOOD_LOCATION_Y)
	    {
		x = antsVector[whichAnt].positionX;
		y = antsVector[whichAnt].positionY + 1;
		return true;
	    }
            sigma += routingTable[antsVector[whichAnt].positionX]
				 [antsVector[whichAnt].positionY + 1];
            possibleStepsCount++;
            possibleStepsMatrix[0][possibleStepsCount] = 
				 antsVector[whichAnt].positionX;
            possibleStepsMatrix[1][possibleStepsCount] = 
				 antsVector[whichAnt].positionY+1;
        }
	
	//(x+1,y+1)
        if (antsVector[whichAnt].positionX < WORLD_SIZE-1)
	    if (!inBlocked(antsVector[whichAnt].positionX+1, 
			    antsVector[whichAnt].positionY+1) && 
		!inTabu(whichAnt, antsVector[whichAnt].positionX+1, 
			antsVector[whichAnt].positionY+1))
	    {
		if (antsVector[whichAnt].positionX+1 == FOOD_LOCATION_X &&
		    antsVector[whichAnt].positionY+1 == FOOD_LOCATION_Y)
		{
		    x = antsVector[whichAnt].positionX + 1;
		    y = antsVector[whichAnt].positionY + 1;
		    return true;
		}
		sigma += routingTable[antsVector[whichAnt].positionX + 1]
				    [antsVector[whichAnt].positionY + 1];
		possibleStepsCount++;
		possibleStepsMatrix[0][possibleStepsCount] = 
				    antsVector[whichAnt].positionX+1;
		possibleStepsMatrix[1][possibleStepsCount] = 
				    antsVector[whichAnt].positionY+1;
	    }
    }

    //(x-1,y)
    if (antsVector[whichAnt].positionX > 0)
    {
	if (!inBlocked(antsVector[whichAnt].positionX-1, 
			antsVector[whichAnt].positionY) && 
	    !inTabu(whichAnt, antsVector[whichAnt].positionX-1, 
		    antsVector[whichAnt].positionY))
	{
	    if (antsVector[whichAnt].positionX-1 == FOOD_LOCATION_X &&
		antsVector[whichAnt].positionY == FOOD_LOCATION_Y)
	    {
		x = antsVector[whichAnt].positionX - 1;
		y = antsVector[whichAnt].positionY;
		return true;
	    }
	    sigma += routingTable[antsVector[whichAnt].positionX-1]
				[antsVector[whichAnt].positionY];
	    possibleStepsCount++;
	    possibleStepsMatrix[0][possibleStepsCount] = 
				    antsVector[whichAnt].positionX-1;
	    possibleStepsMatrix[1][possibleStepsCount] = 
				    antsVector[whichAnt].positionY;
	}
	
	//(x-1,y+1)
        if (antsVector[whichAnt].positionY < WORLD_SIZE-1)
		if (!inBlocked(antsVector[whichAnt].positionX-1, 
			antsVector[whichAnt].positionY+1) && 
		    !inTabu(whichAnt, antsVector[whichAnt].positionX-1,
			    antsVector[whichAnt].positionY+1))
		{
		    if (antsVector[whichAnt].positionX-1 == FOOD_LOCATION_X &&
			antsVector[whichAnt].positionY+1 == FOOD_LOCATION_Y)
		    {
			x = antsVector[whichAnt].positionX - 1;
			y = antsVector[whichAnt].positionY + 1;
			return true;
		    }
		    sigma += routingTable[antsVector[whichAnt].positionX - 1]
			[antsVector[whichAnt].positionY + 1];
		    possibleStepsCount++;
		    possibleStepsMatrix[0][possibleStepsCount] = 
			antsVector[whichAnt].positionX-1;
		    possibleStepsMatrix[1][possibleStepsCount] =
			antsVector[whichAnt].positionY+1;
		}
    }

    //(x+1,y)
    if (antsVector[whichAnt].positionX < WORLD_SIZE-1)
    {
	if (!inBlocked(antsVector[whichAnt].positionX+1, 
			antsVector[whichAnt].positionY) && 
	    !inTabu(whichAnt, antsVector[whichAnt].positionX+1, 
		    antsVector[whichAnt].positionY))
        {
	    if (antsVector[whichAnt].positionX+1 == FOOD_LOCATION_X &&
		antsVector[whichAnt].positionY == FOOD_LOCATION_Y)
	    {
		x = antsVector[whichAnt].positionX + 1;
		y = antsVector[whichAnt].positionY;
		return true;
	    }
            sigma += routingTable[antsVector[whichAnt].positionX+1]
				[antsVector[whichAnt].positionY];
            possibleStepsCount++;
            possibleStepsMatrix[0][possibleStepsCount] = 
				antsVector[whichAnt].positionX+1;
            possibleStepsMatrix[1][possibleStepsCount] = 
				antsVector[whichAnt].positionY;
        }
	
	//(x+1,y-1)
        if (antsVector[whichAnt].positionY > 0)
	    if (!inBlocked(antsVector[whichAnt].positionX+1, 
			antsVector[whichAnt].positionY-1) 
		&& !inTabu(whichAnt, antsVector[whichAnt].positionX+1, 
			   antsVector[whichAnt].positionY-1))
	    {
		if (antsVector[whichAnt].positionX+1 == FOOD_LOCATION_X &&
		    antsVector[whichAnt].positionY-1 == FOOD_LOCATION_Y)
		{
		    x = antsVector[whichAnt].positionX + 1;
		    y = antsVector[whichAnt].positionY - 1;
		    return true;
		}
		sigma += routingTable[antsVector[whichAnt].positionX+1]
				    [antsVector[whichAnt].positionY-1];
		possibleStepsCount++;
		possibleStepsMatrix[0][possibleStepsCount] = 
				    antsVector[whichAnt].positionX+1;
		possibleStepsMatrix[1][possibleStepsCount] = 
				    antsVector[whichAnt].positionY-1;
	    }
    }

    if (possibleStepsCount != -1)
    {
	//daca exista mai multi pasi
	if (possibleStepsCount > 0)
	{
	    //calculeaza probabilitatile pasilor posibili
	    for (i=0; i<possibleStepsCount; i++)
	    {
		probabilities[i] =
			(inter + routingTable[ possibleStepsMatrix[0][i] ]
			    [ possibleStepsMatrix[1][i] ]) / sigma;
		inter += routingTable[possibleStepsMatrix[0][i]]
			[possibleStepsMatrix[1][i]];	
	    }
	    probabilities[possibleStepsCount] = 1;

	    randomPoint = generateRandom();
	    for (i=0; i<=possibleStepsCount; i++)
		if (randomPoint <= probabilities[i])
		{
		    stepX = possibleStepsMatrix[0][i];
		    stepY = possibleStepsMatrix[1][i];
		    break;
		}
	}
	else 
	{
	    stepX = possibleStepsMatrix[0][possibleStepsCount];
	    stepY = possibleStepsMatrix[1][possibleStepsCount];
	}
	
	//returneaza valorile generate
	x = stepX;
	y = stepY;
	return true;	
    }
    else 
    {
	x = -1;
	y = -1;
	return false;
    }
}// end nextStep()

void AntCol::nextGen()
{
int auxStepX, auxStepY;
int i,j,k;
int stuckCount;
int **stuckMatrix = newMatrixInt(2, BLOCKED_SIZE);
//double sigma;   
    
    //initialize variables
    refreshMemory();
    
    //main loop (run ants)
    for (k=0; k<ANTS; k++)
    {
	stuckCount = 0;
	//searching for food...
	while (!antsVector[k].gotFood &&
	    stuckCount < BLOCKED_SIZE)
	    //antsVector[k].stepsCount < BLOCKED_SIZE*4)
	{
	    //next step for ant k
	    if (nextStep(k, auxStepX, auxStepY))// &&
		// !inMatrix(stuckMatrix, stuckCount, auxStepX, auxStepY))
	    {
		antsVector[k].positionX = auxStepX;
		antsVector[k].positionY = auxStepY;
		antsVector[k].tabuMatrix[0][antsVector[k].positionInTabu] = 
		    antsVector[k].positionX;
		antsVector[k].tabuMatrix[1][antsVector[k].positionInTabu] = 
		    antsVector[k].positionY;
		antsVector[k].positionInTabu++;
		antsVector[k].stepsCount++;
		    
		if (antsVector[k].positionX == FOOD_LOCATION_X && 
		    antsVector[k].positionY == FOOD_LOCATION_Y)
		{
		    antsVector[k].gotFood = true;
		    antSuccessful++;
		    //cout<<" Eating. Do not disturb!\n";
		}
	    }
	    else
	    {
		antsVector[k].stepsCount++;
		antsVector[k].positionInTabu--;
		stuckMatrix[0][stuckCount] = auxStepX;
		stuckMatrix[1][stuckCount] = auxStepY;
		stuckCount++;
		
		//antFailed++;
		//cout<<"\n Oh non. Ce n'est pas possible.\n";
	    }
	    //showRoutingTable();
	    //showMatrix(k);
	}//end while	
	
	//updating if not blocked
	if (stuckCount < BLOCKED_SIZE)// !antsVector[k].gotBlocked)
	{   
	    //sigma = 0;
	    for (i=0; i<antsVector[k].positionInTabu; i++)
	    {
		//update tauMatrix
		//add pheromone (PHEROMONE_QUANTITY)
		tauMatrix[ antsVector[k].tabuMatrix[0][i] ]
		    [ antsVector[k].tabuMatrix[1][i] ]+= PHEROMONE_QUANTITY;
		
		//update etaMatrix
		//add 1/steps
		etaMatrix[ antsVector[k].tabuMatrix[0][i] ]
		    [antsVector[k].tabuMatrix[1][i] ]+= 
			(double)WORLD_SIZE / (antsVector[k].stepsCount);
	    
		/*
		//if this is not food
		if (antsVector[k].tabuMatrix[0][i] != FOOD_LOCATION_X &&  
		    antsVector[k].tabuMatrix[1][i] != FOOD_LOCATION_Y)
		    //sigma += 
		    sigma +=pow(tauMatrix[ antsVector[k].tabuMatrix[0][i] ]
			[ antsVector[k].tabuMatrix[1][i] ], 
			    PHEROMONE_ALPHA) *
			    pow(etaMatrix[ antsVector[k].tabuMatrix[0][i] ]
				[ antsVector[k].tabuMatrix[1][i] ],
				    HEURISTIC_BETA);    
		*/
	    }//end for
	   
	    //update routingTable
	    //for (every step) rT += tau*alpha + eta*beta
	    for (i=0; i<antsVector[k].positionInTabu; i++)
	    {
	    routingTable[antsVector[k].tabuMatrix[0][i]]
			[antsVector[k].tabuMatrix[1][i]] +=
		(tauMatrix[antsVector[k].tabuMatrix[0][i]]
			  [antsVector[k].tabuMatrix[1][i]] *
		    PHEROMONE_ALPHA )+
		(etaMatrix[antsVector[k].tabuMatrix[0][i]]
			  [antsVector[k].tabuMatrix[1][i]] *
		    HEURISTIC_BETA ); 
	    }	    
	}//end if
    }//end for (ants)
    
    //evaporate pheromone
    for (i=0; i<WORLD_SIZE; i++)
	for (j=0; j<WORLD_SIZE; j++)
	    tauMatrix[i][j] *= (1-PHEROMONE_EVAP_RO);
      
}//end nextGeneration
