/*********************************************************************--naltu--
 *								VERSION 0.5.1
 *	TODO
 *	#BUGFIX: 
 *	-
 *	-
 *	-
 *	-
 *	
 *	#ADDFUNCTION: 
 *	-
 *
 *****************************************************************************/
#ifndef LIBANTCOL_H
#define LIBANTCOL_H

#include <iostream>
#include <iomanip>
#include <stdlib.h>
#include <time.h>
//#include <math.h>
using namespace std;

class AntCol
{

public:
    AntCol();
    AntCol(int const &size, int const &ants);
    ~AntCol();
    void reinitialize();
    void addToBlocked(int const &x, int const &y);
    void nextGen();
    
    //debug
    void showRoutingTable() const;
    void showMatrix(int const &whichAnt) const; 
    void showSteps(int const &whichAnt) const;

    //ant atributes
    struct ant
    {
	int positionX;
	int positionY;
	int stepsCount;
	int positionInTabu;
	bool gotFood;
	bool gotBlocked;
	int **tabuMatrix;
    };
    ant *antsVector;

//inline
    void setWorldSize(int const &size=5);
    void setFoodLocation(int const &x=3, int const &y=3);
    void setHomeLocation(int const &x=0, int const &y=0);    
    void setHowManyAnts(int const &ants=4);
    void setPheromoneAlpha(int const &alpha=1);
    void setHeuristicBeta(int const &beta=1);
    void setPheromoneEvap(double const &evap=0.1);
    int pheromoneAlpha() const;
    int heuristicBeta() const;
    double pheromoneEvap() const;
    int howManyAnts() const;
    int worldSize() const;
    int homeLocationX() const;
    int homeLocationY() const;
    int foodLocationX() const;
    int foodLocationY() const;
    int successful() const;
    int failed() const;
    double **pheromoneMatrix();
   
private:
//sizes&locations
    int 	WORLD_SIZE;
    int 	TABU_SIZE;
    int 	BLOCKED_SIZE;
    int 	FOOD_LOCATION_X;
    int 	FOOD_LOCATION_Y;
    int 	HOME_LOCATION_X;
    int 	HOME_LOCATION_Y;
    int 	ANTS;    
//initializers&multiplyers
    int 	PHEROMONE_ALPHA; 	//factor feromon
    int 	HEURISTIC_BETA; 	//factor euristic
    double 	PHEROMONE_EVAP_RO;	//factor de evaporare
    int 	PHEROMONE_QUANTITY;	//cantitate de feromon
    int 	INIT_ROUTING_TABLE;
    int 	INIT_PHEROMONE_TAU;
    int 	INIT_HEURISTIC_ETA;
//rewards
    int 	FOOD_REWARD;
    int 	BLOCKED_REWARD;  
//local variables  
    int		antSuccessful;
    int 	antFailed;
    int 	blockedCount;
    double 	**routingTable;
    double 	**tauMatrix;
    double 	**etaMatrix;
    int 	**blockedMatrix;
    
    
//functions    
    double generateRandom(double const range_min=0.0, 
			  double const range_max=1.0) const;
    int **newMatrixInt(int const &m, int const &n);
    double **newMatrixDouble(int const &m, int const &n);
    bool inTabu(int const &whichAnt, int const &x, int const &y) const;
    bool inBlocked(int const &x, int const &y) const;   
    bool inMatrix(int **matrix, int const &count,
		  int const &x, int const &y) const;
    void refreshMemory();
    bool nextStep(int const &whichAnt, int &x, int &y);
};

#endif 
